/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         aalogparse_parse
#define yylex           aalogparse_lex
#define yyerror         aalogparse_error
#define yydebug         aalogparse_debug
#define yynerrs         aalogparse_nerrs


/* Copy the first part of user declarations.  */
#line 19 "grammar.y" /* yacc.c:339  */


/* set the following to non-zero to get bison to emit debugging
 * information about tokens given and rules matched.
 * Also:
 *   Uncomment the %defines
 *   parse.error
 *   parse.trace
 */
#define YYDEBUG 0
#include <string.h>
#include <aalogparse.h>
#include "parser.h"
#include "grammar.h"
#include "scanner.h"

aa_log_record *ret_record;

/* Since we're a library, on any errors we don't want to print out any
 * error messages. We should probably add a debug interface that does
 * emit messages when asked for. */
void aalogparse_error(void *scanner, char const *s)
{
#if (YYDEBUG != 0)
	printf("ERROR: %s\n", s);
#endif
	ret_record->event = AA_RECORD_INVALID;
}

struct aa_type_table {
	unsigned int audit_type;
	aa_record_event_type event;
};

static struct aa_type_table aa_type_table[] = {
	{AUDIT_APPARMOR_AUDIT,   AA_RECORD_AUDIT},
	{AUDIT_APPARMOR_ALLOWED, AA_RECORD_ALLOWED},
	{AUDIT_APPARMOR_DENIED,  AA_RECORD_DENIED},
	{AUDIT_APPARMOR_HINT,    AA_RECORD_HINT},
	{AUDIT_APPARMOR_STATUS,  AA_RECORD_STATUS},
	{AUDIT_APPARMOR_ERROR,   AA_RECORD_ERROR},
	{0,                      AA_RECORD_INVALID},
};

aa_record_event_type lookup_aa_event(unsigned int type)
{
	int i;

	for (i = 0; aa_type_table[i].audit_type != 0; i++)
		if (type == aa_type_table[i].audit_type)
			break;

	return aa_type_table[i].event;
}



#line 130 "grammar.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_AALOGPARSE_GRAMMAR_H_INCLUDED
# define YY_AALOGPARSE_GRAMMAR_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int aalogparse_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_DIGITS = 258,
    TOK_TYPE_UNKNOWN = 259,
    TOK_QUOTED_STRING = 260,
    TOK_ID = 261,
    TOK_MODE = 262,
    TOK_DMESG_STAMP = 263,
    TOK_AUDIT_DIGITS = 264,
    TOK_DATE_MONTH = 265,
    TOK_DATE = 266,
    TOK_TIME = 267,
    TOK_HEXSTRING = 268,
    TOK_TYPE_OTHER = 269,
    TOK_MSG_REST = 270,
    TOK_IP_ADDR = 271,
    TOK_EQUALS = 272,
    TOK_COLON = 273,
    TOK_MINUS = 274,
    TOK_OPEN_PAREN = 275,
    TOK_CLOSE_PAREN = 276,
    TOK_PERIOD = 277,
    TOK_QUESTION_MARK = 278,
    TOK_SINGLE_QUOTE = 279,
    TOK_TYPE_REJECT = 280,
    TOK_TYPE_AUDIT = 281,
    TOK_TYPE_COMPLAIN = 282,
    TOK_TYPE_HINT = 283,
    TOK_TYPE_STATUS = 284,
    TOK_TYPE_ERROR = 285,
    TOK_TYPE_AA_REJECT = 286,
    TOK_TYPE_AA_AUDIT = 287,
    TOK_TYPE_AA_COMPLAIN = 288,
    TOK_TYPE_AA_HINT = 289,
    TOK_TYPE_AA_STATUS = 290,
    TOK_TYPE_AA_ERROR = 291,
    TOK_TYPE_LSM_AVC = 292,
    TOK_TYPE_USER_AVC = 293,
    TOK_KEY_APPARMOR = 294,
    TOK_KEY_TYPE = 295,
    TOK_KEY_MSG = 296,
    TOK_KEY_OPERATION = 297,
    TOK_KEY_NAME = 298,
    TOK_KEY_NAME2 = 299,
    TOK_KEY_MASK = 300,
    TOK_KEY_DENIED_MASK = 301,
    TOK_KEY_REQUESTED_MASK = 302,
    TOK_KEY_ATTRIBUTE = 303,
    TOK_KEY_TASK = 304,
    TOK_KEY_PARENT = 305,
    TOK_KEY_MAGIC_TOKEN = 306,
    TOK_KEY_INFO = 307,
    TOK_KEY_PEER_INFO = 308,
    TOK_KEY_PID = 309,
    TOK_KEY_PEER_PID = 310,
    TOK_KEY_PROFILE = 311,
    TOK_KEY_PEER_PROFILE = 312,
    TOK_KEY_LABEL = 313,
    TOK_KEY_PEER_LABEL = 314,
    TOK_KEY_PEER = 315,
    TOK_AUDIT = 316,
    TOK_KEY_FAMILY = 317,
    TOK_KEY_SOCK_TYPE = 318,
    TOK_KEY_PROTOCOL = 319,
    TOK_KEY_NAMESPACE = 320,
    TOK_KEY_ERROR = 321,
    TOK_KEY_FSUID = 322,
    TOK_KEY_OUID = 323,
    TOK_KEY_UID = 324,
    TOK_KEY_AUID = 325,
    TOK_KEY_SAUID = 326,
    TOK_KEY_SES = 327,
    TOK_KEY_HOSTNAME = 328,
    TOK_KEY_ADDR = 329,
    TOK_KEY_TERMINAL = 330,
    TOK_KEY_EXE = 331,
    TOK_KEY_COMM = 332,
    TOK_KEY_CAPABILITY = 333,
    TOK_KEY_CAPNAME = 334,
    TOK_KEY_OFFSET = 335,
    TOK_KEY_TARGET = 336,
    TOK_KEY_LADDR = 337,
    TOK_KEY_FADDR = 338,
    TOK_KEY_LPORT = 339,
    TOK_KEY_FPORT = 340,
    TOK_KEY_BUS = 341,
    TOK_KEY_PATH = 342,
    TOK_KEY_INTERFACE = 343,
    TOK_KEY_MEMBER = 344,
    TOK_KEY_SIGNAL = 345,
    TOK_KEY_FSTYPE = 346,
    TOK_KEY_FLAGS = 347,
    TOK_KEY_SRCNAME = 348,
    TOK_SYSLOG_KERNEL = 349,
    TOK_SYSLOG_USER = 350
  };
#endif
/* Tokens.  */
#define TOK_DIGITS 258
#define TOK_TYPE_UNKNOWN 259
#define TOK_QUOTED_STRING 260
#define TOK_ID 261
#define TOK_MODE 262
#define TOK_DMESG_STAMP 263
#define TOK_AUDIT_DIGITS 264
#define TOK_DATE_MONTH 265
#define TOK_DATE 266
#define TOK_TIME 267
#define TOK_HEXSTRING 268
#define TOK_TYPE_OTHER 269
#define TOK_MSG_REST 270
#define TOK_IP_ADDR 271
#define TOK_EQUALS 272
#define TOK_COLON 273
#define TOK_MINUS 274
#define TOK_OPEN_PAREN 275
#define TOK_CLOSE_PAREN 276
#define TOK_PERIOD 277
#define TOK_QUESTION_MARK 278
#define TOK_SINGLE_QUOTE 279
#define TOK_TYPE_REJECT 280
#define TOK_TYPE_AUDIT 281
#define TOK_TYPE_COMPLAIN 282
#define TOK_TYPE_HINT 283
#define TOK_TYPE_STATUS 284
#define TOK_TYPE_ERROR 285
#define TOK_TYPE_AA_REJECT 286
#define TOK_TYPE_AA_AUDIT 287
#define TOK_TYPE_AA_COMPLAIN 288
#define TOK_TYPE_AA_HINT 289
#define TOK_TYPE_AA_STATUS 290
#define TOK_TYPE_AA_ERROR 291
#define TOK_TYPE_LSM_AVC 292
#define TOK_TYPE_USER_AVC 293
#define TOK_KEY_APPARMOR 294
#define TOK_KEY_TYPE 295
#define TOK_KEY_MSG 296
#define TOK_KEY_OPERATION 297
#define TOK_KEY_NAME 298
#define TOK_KEY_NAME2 299
#define TOK_KEY_MASK 300
#define TOK_KEY_DENIED_MASK 301
#define TOK_KEY_REQUESTED_MASK 302
#define TOK_KEY_ATTRIBUTE 303
#define TOK_KEY_TASK 304
#define TOK_KEY_PARENT 305
#define TOK_KEY_MAGIC_TOKEN 306
#define TOK_KEY_INFO 307
#define TOK_KEY_PEER_INFO 308
#define TOK_KEY_PID 309
#define TOK_KEY_PEER_PID 310
#define TOK_KEY_PROFILE 311
#define TOK_KEY_PEER_PROFILE 312
#define TOK_KEY_LABEL 313
#define TOK_KEY_PEER_LABEL 314
#define TOK_KEY_PEER 315
#define TOK_AUDIT 316
#define TOK_KEY_FAMILY 317
#define TOK_KEY_SOCK_TYPE 318
#define TOK_KEY_PROTOCOL 319
#define TOK_KEY_NAMESPACE 320
#define TOK_KEY_ERROR 321
#define TOK_KEY_FSUID 322
#define TOK_KEY_OUID 323
#define TOK_KEY_UID 324
#define TOK_KEY_AUID 325
#define TOK_KEY_SAUID 326
#define TOK_KEY_SES 327
#define TOK_KEY_HOSTNAME 328
#define TOK_KEY_ADDR 329
#define TOK_KEY_TERMINAL 330
#define TOK_KEY_EXE 331
#define TOK_KEY_COMM 332
#define TOK_KEY_CAPABILITY 333
#define TOK_KEY_CAPNAME 334
#define TOK_KEY_OFFSET 335
#define TOK_KEY_TARGET 336
#define TOK_KEY_LADDR 337
#define TOK_KEY_FADDR 338
#define TOK_KEY_LPORT 339
#define TOK_KEY_FPORT 340
#define TOK_KEY_BUS 341
#define TOK_KEY_PATH 342
#define TOK_KEY_INTERFACE 343
#define TOK_KEY_MEMBER 344
#define TOK_KEY_SIGNAL 345
#define TOK_KEY_FSTYPE 346
#define TOK_KEY_FLAGS 347
#define TOK_KEY_SRCNAME 348
#define TOK_SYSLOG_KERNEL 349
#define TOK_SYSLOG_USER 350

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 88 "grammar.y" /* yacc.c:355  */

	char	*t_str;
	long	t_long;

#line 365 "grammar.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int aalogparse_parse (void *scanner);

#endif /* !YY_AALOGPARSE_GRAMMAR_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 381 "grammar.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  18
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   356

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  96
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  27
/* YYNRULES -- Number of rules.  */
#define YYNRULES  110
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  296

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   350

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   190,   190,   191,   192,   193,   196,   198,   199,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   214,   222,
     227,   229,   231,   233,   236,   238,   240,   242,   244,   250,
     253,   256,   259,   262,   265,   276,   278,   282,   283,   286,
     288,   290,   292,   294,   296,   298,   300,   302,   304,   306,
     308,   310,   312,   314,   315,   316,   318,   320,   322,   324,
     326,   328,   330,   332,   334,   336,   338,   340,   342,   344,
     345,   346,   347,   349,   351,   357,   363,   364,   370,   374,
     379,   383,   385,   387,   389,   391,   393,   395,   397,   399,
     402,   404,   406,   409,   417,   418,   419,   420,   421,   422,
     425,   428,   431,   432,   433,   434,   436,   439,   440,   443,
     444
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_DIGITS", "TOK_TYPE_UNKNOWN",
  "TOK_QUOTED_STRING", "TOK_ID", "TOK_MODE", "TOK_DMESG_STAMP",
  "TOK_AUDIT_DIGITS", "TOK_DATE_MONTH", "TOK_DATE", "TOK_TIME",
  "TOK_HEXSTRING", "TOK_TYPE_OTHER", "TOK_MSG_REST", "TOK_IP_ADDR",
  "TOK_EQUALS", "TOK_COLON", "TOK_MINUS", "TOK_OPEN_PAREN",
  "TOK_CLOSE_PAREN", "TOK_PERIOD", "TOK_QUESTION_MARK", "TOK_SINGLE_QUOTE",
  "TOK_TYPE_REJECT", "TOK_TYPE_AUDIT", "TOK_TYPE_COMPLAIN",
  "TOK_TYPE_HINT", "TOK_TYPE_STATUS", "TOK_TYPE_ERROR",
  "TOK_TYPE_AA_REJECT", "TOK_TYPE_AA_AUDIT", "TOK_TYPE_AA_COMPLAIN",
  "TOK_TYPE_AA_HINT", "TOK_TYPE_AA_STATUS", "TOK_TYPE_AA_ERROR",
  "TOK_TYPE_LSM_AVC", "TOK_TYPE_USER_AVC", "TOK_KEY_APPARMOR",
  "TOK_KEY_TYPE", "TOK_KEY_MSG", "TOK_KEY_OPERATION", "TOK_KEY_NAME",
  "TOK_KEY_NAME2", "TOK_KEY_MASK", "TOK_KEY_DENIED_MASK",
  "TOK_KEY_REQUESTED_MASK", "TOK_KEY_ATTRIBUTE", "TOK_KEY_TASK",
  "TOK_KEY_PARENT", "TOK_KEY_MAGIC_TOKEN", "TOK_KEY_INFO",
  "TOK_KEY_PEER_INFO", "TOK_KEY_PID", "TOK_KEY_PEER_PID",
  "TOK_KEY_PROFILE", "TOK_KEY_PEER_PROFILE", "TOK_KEY_LABEL",
  "TOK_KEY_PEER_LABEL", "TOK_KEY_PEER", "TOK_AUDIT", "TOK_KEY_FAMILY",
  "TOK_KEY_SOCK_TYPE", "TOK_KEY_PROTOCOL", "TOK_KEY_NAMESPACE",
  "TOK_KEY_ERROR", "TOK_KEY_FSUID", "TOK_KEY_OUID", "TOK_KEY_UID",
  "TOK_KEY_AUID", "TOK_KEY_SAUID", "TOK_KEY_SES", "TOK_KEY_HOSTNAME",
  "TOK_KEY_ADDR", "TOK_KEY_TERMINAL", "TOK_KEY_EXE", "TOK_KEY_COMM",
  "TOK_KEY_CAPABILITY", "TOK_KEY_CAPNAME", "TOK_KEY_OFFSET",
  "TOK_KEY_TARGET", "TOK_KEY_LADDR", "TOK_KEY_FADDR", "TOK_KEY_LPORT",
  "TOK_KEY_FPORT", "TOK_KEY_BUS", "TOK_KEY_PATH", "TOK_KEY_INTERFACE",
  "TOK_KEY_MEMBER", "TOK_KEY_SIGNAL", "TOK_KEY_FSTYPE", "TOK_KEY_FLAGS",
  "TOK_KEY_SRCNAME", "TOK_SYSLOG_KERNEL", "TOK_SYSLOG_USER", "$accept",
  "log_message", "audit_type", "type_syntax", "new_syntax", "other_audit",
  "dmesg_type", "syslog_type", "audit_dispatch", "audit_msg",
  "audit_user_msg_partial_tail", "audit_user_msg_tail", "audit_user_msg",
  "audit_id", "syslog_date", "key_list", "key", "apparmor_event",
  "key_pid", "key_peer_pid", "ignored_pid", "ignored_uid", "ignored_auid",
  "ignored_ses", "key_type", "safe_string", "protocol", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350
};
# endif

#define YYPACT_NINF -144

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-144)))

#define YYTABLE_NINF -103

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      77,   -42,    21,    16,    31,    39,    59,  -144,  -144,  -144,
    -144,   -13,    78,    76,    87,  -144,   102,    36,  -144,  -144,
      84,    98,   103,   105,   107,   109,   111,   112,   113,   135,
     136,   137,   138,   139,   141,   142,   158,   160,   161,   163,
     164,   165,   167,   168,   170,   171,   172,   173,   174,   175,
     177,   178,   179,   180,   181,   183,   185,   186,   187,   188,
     189,   190,   191,   192,   194,   195,   196,   197,   198,   199,
     -13,  -144,  -144,  -144,    -3,    67,  -144,   120,   120,   120,
     120,   120,   120,   120,   120,   120,   176,  -144,  -144,  -144,
      99,  -144,   144,   215,   214,     9,     9,   216,   217,   240,
     248,   251,   253,   276,   275,   277,   278,   280,     9,     9,
       9,     9,   279,   281,   282,    12,     9,     2,   285,   286,
     291,    85,    90,   118,     9,     9,   292,   294,   293,     9,
     204,   269,   297,   298,   303,   304,   305,   307,   296,   308,
     309,   310,  -144,    49,   -13,   299,    36,   -13,   302,   -13,
     -13,   -13,   -13,   -13,   -13,   -13,   301,  -144,   288,  -144,
    -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,
    -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,
    -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,
    -144,  -144,  -144,  -144,  -144,   316,  -144,  -144,  -144,  -144,
    -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,
    -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,
    -144,  -144,  -144,    41,     0,   -13,    36,   -13,   317,   -13,
     -13,  -144,   -13,   -13,   -13,   -13,   -13,   -13,   -13,    36,
     300,  -144,     5,   -13,    36,    67,   -13,   -13,  -144,   -13,
     267,   314,    67,   -13,   -13,    36,   -13,   311,   306,  -144,
     255,   313,    36,   -13,   -13,   322,  -144,   312,   256,   318,
     184,   -13,  -144,   329,   319,   261,   320,   321,   306,  -144,
     -13,  -144,   331,   323,   315,   324,   332,  -144,   334,   326,
    -144,   270,  -144,   325,   -13,   -13
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     2,     3,     4,
       5,     0,     0,     0,     0,    36,     0,     0,     1,    93,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      29,    37,    53,    54,     0,     0,    35,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     6,     7,     8,
       0,    30,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    38,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    17,     0,    94,
      95,    96,    97,    98,    99,    76,    62,    39,   107,   108,
      40,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,   100,   101,    55,    56,    57,    58,    52,    59,    60,
     110,   109,    61,    41,    63,     0,    65,    66,    67,    69,
      68,    70,    72,    71,    73,    74,    75,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,     0,     0,     0,     0,    28,     0,     0,
      15,    18,     9,    10,    11,    12,    13,    14,    16,     0,
       0,    64,     0,     0,     0,     0,    20,     0,   106,    19,
       0,     0,     0,    22,     0,     0,    21,     0,     0,    33,
       0,     0,     0,    23,     0,     0,    32,     0,     0,     0,
       0,    27,   102,     0,     0,     0,     0,     0,    24,    25,
      26,   103,     0,     0,     0,     0,     0,   104,     0,     0,
      34,   100,   105,     0,     0,    31
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,  -144,    65,
      74,    75,  -144,  -130,  -144,  -143,   -70,  -144,  -144,  -144,
    -144,  -144,  -144,  -144,  -140,   182,  -144
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     6,     7,    87,    88,    89,     8,     9,    10,    11,
     258,   259,   157,    91,    12,    70,    71,   165,    72,    73,
     260,   268,   275,   284,   146,   170,   192
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     142,   227,    19,   226,   230,   194,   232,   233,   234,   235,
     236,   237,   238,   225,   168,   190,   229,   191,   245,    13,
     158,   195,   169,   252,    14,   158,    20,    21,    15,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    16,    41,
      42,    43,    44,    45,    46,    47,    17,   223,    48,    18,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,   145,   246,   244,    74,     1,   249,     2,     3,   145,
     168,   143,   144,   243,    75,   168,   247,    90,   169,    76,
     253,    92,   242,   169,   256,   255,    77,   145,   199,   250,
     224,   263,   262,   201,   254,    93,    78,     4,     5,   158,
      94,   271,    95,   168,    96,   264,    97,   280,    98,    99,
     100,   169,   270,    79,    80,    81,    82,    83,    84,    85,
      86,   203,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   295,   101,   102,   103,   104,   105,   142,   106,   107,
     142,     5,   142,   142,   142,   142,   142,   142,   142,   159,
     160,   161,   162,   163,   164,   108,   142,   109,   110,   142,
     111,   112,   113,   142,   114,   115,   142,   116,   117,   118,
     119,   120,   121,   142,   122,   123,   124,   125,   126,    19,
     127,   142,   128,   129,   130,   131,   132,   133,   134,   135,
     142,   136,   137,   138,   139,   140,   141,   156,   166,   167,
     211,   172,   173,    20,    21,   142,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,   277,    35,
      36,    37,    38,    39,    40,   174,    41,    42,    43,    44,
      45,    46,    47,   175,   176,    48,   177,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,   171,   178,
     179,   181,   180,   182,   187,   212,   188,   189,   196,   197,
     183,   184,   185,   186,   198,   207,   209,   240,   193,   208,
     213,   214,   219,   200,   202,   204,   205,   206,   215,   216,
     217,   210,   218,   220,   221,   222,   228,   231,   239,   241,
     248,   257,   251,   261,   267,   272,   274,   276,   265,   273,
     266,   269,   281,   283,   287,   291,   282,   292,   286,  -102,
     288,   285,   290,   293,   278,   279,     0,     0,     0,   294,
       0,     0,     0,     0,     0,     0,   289
};

static const yytype_int16 yycheck[] =
{
      70,   144,    15,   143,   147,     3,   149,   150,   151,   152,
     153,   154,   155,   143,     5,     3,   146,     5,    18,    61,
      20,    19,    13,    18,     3,    20,    39,    40,    12,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    17,    62,
      63,    64,    65,    66,    67,    68,    17,     8,    71,     0,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    40,   225,   223,     6,     8,   229,    10,    11,    40,
       5,    94,    95,   223,    18,     5,   226,    61,    13,    12,
     243,    17,    61,    13,   247,   245,     4,    40,    23,   239,
      61,   254,   252,    23,   244,    17,    14,    40,    41,    20,
      17,   264,    17,     5,    17,   255,    17,   270,    17,    17,
      17,    13,   262,    31,    32,    33,    34,    35,    36,    37,
      38,    23,    77,    78,    79,    80,    81,    82,    83,    84,
      85,   294,    17,    17,    17,    17,    17,   227,    17,    17,
     230,    41,   232,   233,   234,   235,   236,   237,   238,    25,
      26,    27,    28,    29,    30,    17,   246,    17,    17,   249,
      17,    17,    17,   253,    17,    17,   256,    17,    17,    17,
      17,    17,    17,   263,    17,    17,    17,    17,    17,    15,
      17,   271,    17,    17,    17,    17,    17,    17,    17,    17,
     280,    17,    17,    17,    17,    17,    17,    41,     3,     5,
      16,     5,     5,    39,    40,   295,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,     5,    62,    63,    64,    65,
      66,    67,    68,     5,     3,    71,     3,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    96,     3,
       5,     3,     5,     3,     5,    16,     5,     5,     3,     3,
     108,   109,   110,   111,     3,     3,     3,     9,   116,     5,
       3,     3,     6,   121,   122,   123,   124,   125,     5,     5,
       5,   129,     5,     5,     5,     5,    17,    15,    17,     3,
       3,    54,    22,     9,    69,     3,    70,     9,    17,    17,
      24,    18,     3,    72,     3,     3,    17,     3,    17,    69,
      17,    21,    18,    17,   270,   270,    -1,    -1,    -1,    24,
      -1,    -1,    -1,    -1,    -1,    -1,    41
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     8,    10,    11,    40,    41,    97,    98,   102,   103,
     104,   105,   110,    61,     3,    12,    17,    17,     0,    15,
      39,    40,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    62,    63,    64,    65,    66,    67,    68,    71,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
     111,   112,   114,   115,     6,    18,    12,     4,    14,    31,
      32,    33,    34,    35,    36,    37,    38,    99,   100,   101,
      61,   109,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,    17,    17,    17,    17,    17,    17,    17,    17,
      17,    17,   112,    94,    95,    40,   120,   105,   105,   105,
     105,   105,   105,   105,   105,   105,    41,   108,    20,    25,
      26,    27,    28,    29,    30,   113,     3,     5,     5,    13,
     121,   121,     5,     5,     5,     5,     3,     3,     3,     5,
       5,     3,     3,   121,   121,   121,   121,     5,     5,     5,
       3,     5,   122,   121,     3,    19,     3,     3,     3,    23,
     121,    23,   121,    23,   121,   121,   121,     3,     5,     3,
     121,    16,    16,     3,     3,     5,     5,     5,     5,     6,
       5,     5,     5,     8,    61,   109,   120,   111,    17,   109,
     111,    15,   111,   111,   111,   111,   111,   111,   111,    17,
       9,     3,    61,   109,   120,    18,   111,   109,     3,   111,
     109,    22,    18,   111,   109,   120,   111,    54,   106,   107,
     116,     9,   120,   111,   109,    17,    24,    69,   117,    18,
     109,   111,     3,    17,    70,   118,     9,    54,   106,   107,
     111,     3,    17,    72,   119,    21,    17,     3,    17,    41,
      18,     3,     3,    17,    24,   111
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    96,    97,    97,    97,    97,    98,    99,    99,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   101,   102,
     103,   103,   103,   103,   103,   103,   103,   103,   103,   104,
     105,   106,   107,   108,   109,   110,   110,   111,   111,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   113,   113,   113,   113,   113,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   121,   122,
     122
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     3,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     3,     6,
       5,     6,     6,     7,     9,     9,     9,     8,     4,     2,
       3,     8,     2,     4,     9,     3,     2,     1,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     1,     1,     1,
       1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (scanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, scanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, void *scanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (scanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, void *scanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, scanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, void *scanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              , scanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, scanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, void *scanner)
{
  YYUSE (yyvaluep);
  YYUSE (scanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yytype)
    {
          case 5: /* TOK_QUOTED_STRING  */
#line 183 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1439 "grammar.c" /* yacc.c:1257  */
        break;

    case 6: /* TOK_ID  */
#line 183 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1445 "grammar.c" /* yacc.c:1257  */
        break;

    case 7: /* TOK_MODE  */
#line 183 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1451 "grammar.c" /* yacc.c:1257  */
        break;

    case 8: /* TOK_DMESG_STAMP  */
#line 183 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1457 "grammar.c" /* yacc.c:1257  */
        break;

    case 9: /* TOK_AUDIT_DIGITS  */
#line 184 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1463 "grammar.c" /* yacc.c:1257  */
        break;

    case 10: /* TOK_DATE_MONTH  */
#line 184 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1469 "grammar.c" /* yacc.c:1257  */
        break;

    case 11: /* TOK_DATE  */
#line 184 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1475 "grammar.c" /* yacc.c:1257  */
        break;

    case 12: /* TOK_TIME  */
#line 184 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1481 "grammar.c" /* yacc.c:1257  */
        break;

    case 13: /* TOK_HEXSTRING  */
#line 185 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1487 "grammar.c" /* yacc.c:1257  */
        break;

    case 14: /* TOK_TYPE_OTHER  */
#line 185 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1493 "grammar.c" /* yacc.c:1257  */
        break;

    case 15: /* TOK_MSG_REST  */
#line 185 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1499 "grammar.c" /* yacc.c:1257  */
        break;

    case 16: /* TOK_IP_ADDR  */
#line 186 "grammar.y" /* yacc.c:1257  */
      { free(((*yyvaluep).t_str)); }
#line 1505 "grammar.c" /* yacc.c:1257  */
        break;


      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void *scanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, scanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 7:
#line 198 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
#line 1773 "grammar.c" /* yacc.c:1646  */
    break;

  case 9:
#line 203 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_DENIED; }
#line 1779 "grammar.c" /* yacc.c:1646  */
    break;

  case 10:
#line 204 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_AUDIT; }
#line 1785 "grammar.c" /* yacc.c:1646  */
    break;

  case 11:
#line 205 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_ALLOWED; }
#line 1791 "grammar.c" /* yacc.c:1646  */
    break;

  case 12:
#line 206 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_HINT; }
#line 1797 "grammar.c" /* yacc.c:1646  */
    break;

  case 13:
#line 207 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_STATUS; }
#line 1803 "grammar.c" /* yacc.c:1646  */
    break;

  case 14:
#line 208 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_ERROR; }
#line 1809 "grammar.c" /* yacc.c:1646  */
    break;

  case 15:
#line 209 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = lookup_aa_event((yyvsp[-2].t_long)); }
#line 1815 "grammar.c" /* yacc.c:1646  */
    break;

  case 18:
#line 215 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->operation = (yyvsp[-2].t_str);
		ret_record->event = AA_RECORD_INVALID;
		ret_record->info = (yyvsp[0].t_str);
	}
#line 1825 "grammar.c" /* yacc.c:1646  */
    break;

  case 19:
#line 223 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-5].t_str)); }
#line 1831 "grammar.c" /* yacc.c:1646  */
    break;

  case 20:
#line 228 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-3].t_str)); }
#line 1837 "grammar.c" /* yacc.c:1646  */
    break;

  case 21:
#line 230 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-4].t_str)); }
#line 1843 "grammar.c" /* yacc.c:1646  */
    break;

  case 22:
#line 232 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-4].t_str)); free((yyvsp[-2].t_str)); }
#line 1849 "grammar.c" /* yacc.c:1646  */
    break;

  case 23:
#line 234 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-5].t_str)); free((yyvsp[-3].t_str)); }
#line 1855 "grammar.c" /* yacc.c:1646  */
    break;

  case 24:
#line 237 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-7].t_str)); }
#line 1861 "grammar.c" /* yacc.c:1646  */
    break;

  case 25:
#line 239 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-7].t_str)); }
#line 1867 "grammar.c" /* yacc.c:1646  */
    break;

  case 26:
#line 241 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-7].t_str)); free((yyvsp[-5].t_str)); }
#line 1873 "grammar.c" /* yacc.c:1646  */
    break;

  case 27:
#line 243 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-6].t_str)); }
#line 1879 "grammar.c" /* yacc.c:1646  */
    break;

  case 28:
#line 245 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; free((yyvsp[-2].t_str)); }
#line 1885 "grammar.c" /* yacc.c:1646  */
    break;

  case 29:
#line 250 "grammar.y" /* yacc.c:1646  */
    { ret_record->version = AA_RECORD_SYNTAX_V2; }
#line 1891 "grammar.c" /* yacc.c:1646  */
    break;

  case 34:
#line 266 "grammar.y" /* yacc.c:1646  */
    {
		if (!asprintf(&ret_record->audit_id, "%s.%s:%s", (yyvsp[-6].t_str), (yyvsp[-4].t_str), (yyvsp[-2].t_str)))
			yyerror(scanner, YY_("Out of memory"));
		ret_record->epoch = atol((yyvsp[-6].t_str));
		ret_record->audit_sub_id = atoi((yyvsp[-2].t_str));
		free((yyvsp[-6].t_str));
		free((yyvsp[-4].t_str));
		free((yyvsp[-2].t_str));
	}
#line 1905 "grammar.c" /* yacc.c:1646  */
    break;

  case 35:
#line 277 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[-2].t_str)); free((yyvsp[0].t_str)); /* do nothing */ }
#line 1911 "grammar.c" /* yacc.c:1646  */
    break;

  case 36:
#line 279 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[-1].t_str)); free((yyvsp[0].t_str)); /* do nothing */ }
#line 1917 "grammar.c" /* yacc.c:1646  */
    break;

  case 39:
#line 287 "grammar.y" /* yacc.c:1646  */
    { ret_record->operation = (yyvsp[0].t_str);}
#line 1923 "grammar.c" /* yacc.c:1646  */
    break;

  case 40:
#line 289 "grammar.y" /* yacc.c:1646  */
    { ret_record->name = (yyvsp[0].t_str);}
#line 1929 "grammar.c" /* yacc.c:1646  */
    break;

  case 41:
#line 291 "grammar.y" /* yacc.c:1646  */
    { ret_record->namespace = (yyvsp[0].t_str);}
#line 1935 "grammar.c" /* yacc.c:1646  */
    break;

  case 42:
#line 293 "grammar.y" /* yacc.c:1646  */
    { ret_record->name2 = (yyvsp[0].t_str);}
#line 1941 "grammar.c" /* yacc.c:1646  */
    break;

  case 43:
#line 295 "grammar.y" /* yacc.c:1646  */
    { ret_record->denied_mask = (yyvsp[0].t_str);}
#line 1947 "grammar.c" /* yacc.c:1646  */
    break;

  case 44:
#line 297 "grammar.y" /* yacc.c:1646  */
    { ret_record->denied_mask = (yyvsp[0].t_str);}
#line 1953 "grammar.c" /* yacc.c:1646  */
    break;

  case 45:
#line 299 "grammar.y" /* yacc.c:1646  */
    { ret_record->requested_mask = (yyvsp[0].t_str);}
#line 1959 "grammar.c" /* yacc.c:1646  */
    break;

  case 46:
#line 301 "grammar.y" /* yacc.c:1646  */
    { ret_record->attribute = (yyvsp[0].t_str);}
#line 1965 "grammar.c" /* yacc.c:1646  */
    break;

  case 47:
#line 303 "grammar.y" /* yacc.c:1646  */
    { ret_record->task = (yyvsp[0].t_long);}
#line 1971 "grammar.c" /* yacc.c:1646  */
    break;

  case 48:
#line 305 "grammar.y" /* yacc.c:1646  */
    { ret_record->parent = (yyvsp[0].t_long);}
#line 1977 "grammar.c" /* yacc.c:1646  */
    break;

  case 49:
#line 307 "grammar.y" /* yacc.c:1646  */
    { ret_record->magic_token = (yyvsp[0].t_long);}
#line 1983 "grammar.c" /* yacc.c:1646  */
    break;

  case 50:
#line 309 "grammar.y" /* yacc.c:1646  */
    { ret_record->info = (yyvsp[0].t_str);}
#line 1989 "grammar.c" /* yacc.c:1646  */
    break;

  case 51:
#line 311 "grammar.y" /* yacc.c:1646  */
    { ret_record->peer_info = (yyvsp[0].t_str);}
#line 1995 "grammar.c" /* yacc.c:1646  */
    break;

  case 52:
#line 313 "grammar.y" /* yacc.c:1646  */
    { ret_record->peer = (yyvsp[0].t_str);}
#line 2001 "grammar.c" /* yacc.c:1646  */
    break;

  case 55:
#line 317 "grammar.y" /* yacc.c:1646  */
    { ret_record->profile = (yyvsp[0].t_str);}
#line 2007 "grammar.c" /* yacc.c:1646  */
    break;

  case 56:
#line 319 "grammar.y" /* yacc.c:1646  */
    { ret_record->peer_profile = (yyvsp[0].t_str);}
#line 2013 "grammar.c" /* yacc.c:1646  */
    break;

  case 57:
#line 321 "grammar.y" /* yacc.c:1646  */
    { ret_record->profile = (yyvsp[0].t_str);}
#line 2019 "grammar.c" /* yacc.c:1646  */
    break;

  case 58:
#line 323 "grammar.y" /* yacc.c:1646  */
    { ret_record->peer_profile = (yyvsp[0].t_str);}
#line 2025 "grammar.c" /* yacc.c:1646  */
    break;

  case 59:
#line 325 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_family = (yyvsp[0].t_str);}
#line 2031 "grammar.c" /* yacc.c:1646  */
    break;

  case 60:
#line 327 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_sock_type = (yyvsp[0].t_str);}
#line 2037 "grammar.c" /* yacc.c:1646  */
    break;

  case 61:
#line 329 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_protocol = (yyvsp[0].t_str);}
#line 2043 "grammar.c" /* yacc.c:1646  */
    break;

  case 62:
#line 331 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = lookup_aa_event((yyvsp[0].t_long));}
#line 2049 "grammar.c" /* yacc.c:1646  */
    break;

  case 63:
#line 333 "grammar.y" /* yacc.c:1646  */
    { ret_record->error_code = (yyvsp[0].t_long);}
#line 2055 "grammar.c" /* yacc.c:1646  */
    break;

  case 64:
#line 335 "grammar.y" /* yacc.c:1646  */
    { ret_record->error_code = (yyvsp[0].t_long);}
#line 2061 "grammar.c" /* yacc.c:1646  */
    break;

  case 65:
#line 337 "grammar.y" /* yacc.c:1646  */
    { ret_record->fsuid = (yyvsp[0].t_long);}
#line 2067 "grammar.c" /* yacc.c:1646  */
    break;

  case 66:
#line 339 "grammar.y" /* yacc.c:1646  */
    { ret_record->ouid = (yyvsp[0].t_long);}
#line 2073 "grammar.c" /* yacc.c:1646  */
    break;

  case 67:
#line 341 "grammar.y" /* yacc.c:1646  */
    { /* Ignore - Source audit ID from user AVC messages */ }
#line 2079 "grammar.c" /* yacc.c:1646  */
    break;

  case 68:
#line 343 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[0].t_str)); /* Ignore - hostname from user AVC messages */ }
#line 2085 "grammar.c" /* yacc.c:1646  */
    break;

  case 72:
#line 348 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[0].t_str)); /* Ignore - IP address from user AVC messages */ }
#line 2091 "grammar.c" /* yacc.c:1646  */
    break;

  case 73:
#line 350 "grammar.y" /* yacc.c:1646  */
    { free((yyvsp[0].t_str)); /* Ignore - TTY from user AVC messages */ }
#line 2097 "grammar.c" /* yacc.c:1646  */
    break;

  case 74:
#line 352 "grammar.y" /* yacc.c:1646  */
    { /* Free existing arrays because exe= and comm= maps to the same
	     aa_log_record member */
	  free(ret_record->comm);
	  ret_record->comm = (yyvsp[0].t_str);
	}
#line 2107 "grammar.c" /* yacc.c:1646  */
    break;

  case 75:
#line 358 "grammar.y" /* yacc.c:1646  */
    { /* Free existing arrays because exe= and comm= maps to the same
	     aa_log_record member */
	  free(ret_record->comm);
	  ret_record->comm = (yyvsp[0].t_str);
	}
#line 2117 "grammar.c" /* yacc.c:1646  */
    break;

  case 77:
#line 365 "grammar.y" /* yacc.c:1646  */
    { /* need to reverse map number to string, need to figure out
	   * how to get auto generation of reverse mapping table into
	   * autotools Makefile.  For now just drop assumming capname is
	   * present which it should be with current kernels */
	}
#line 2127 "grammar.c" /* yacc.c:1646  */
    break;

  case 78:
#line 371 "grammar.y" /* yacc.c:1646  */
    { /* capname used to be reported in name */
	  ret_record->name = (yyvsp[0].t_str);
	}
#line 2135 "grammar.c" /* yacc.c:1646  */
    break;

  case 79:
#line 375 "grammar.y" /* yacc.c:1646  */
    { /* offset is used for reporting where an error occured unpacking
	   * loaded policy.  We can just drop this currently
	   */
	}
#line 2144 "grammar.c" /* yacc.c:1646  */
    break;

  case 80:
#line 380 "grammar.y" /* yacc.c:1646  */
    { /* target was always name2 in the past */
	  ret_record->name2 = (yyvsp[0].t_str);
	}
#line 2152 "grammar.c" /* yacc.c:1646  */
    break;

  case 81:
#line 384 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_local_addr = (yyvsp[0].t_str);}
#line 2158 "grammar.c" /* yacc.c:1646  */
    break;

  case 82:
#line 386 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_foreign_addr = (yyvsp[0].t_str);}
#line 2164 "grammar.c" /* yacc.c:1646  */
    break;

  case 83:
#line 388 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_local_port = (yyvsp[0].t_long);}
#line 2170 "grammar.c" /* yacc.c:1646  */
    break;

  case 84:
#line 390 "grammar.y" /* yacc.c:1646  */
    { ret_record->net_foreign_port = (yyvsp[0].t_long);}
#line 2176 "grammar.c" /* yacc.c:1646  */
    break;

  case 85:
#line 392 "grammar.y" /* yacc.c:1646  */
    { ret_record->dbus_bus = (yyvsp[0].t_str); }
#line 2182 "grammar.c" /* yacc.c:1646  */
    break;

  case 86:
#line 394 "grammar.y" /* yacc.c:1646  */
    { ret_record->dbus_path = (yyvsp[0].t_str); }
#line 2188 "grammar.c" /* yacc.c:1646  */
    break;

  case 87:
#line 396 "grammar.y" /* yacc.c:1646  */
    { ret_record->dbus_interface = (yyvsp[0].t_str); }
#line 2194 "grammar.c" /* yacc.c:1646  */
    break;

  case 88:
#line 398 "grammar.y" /* yacc.c:1646  */
    { ret_record->dbus_member = (yyvsp[0].t_str); }
#line 2200 "grammar.c" /* yacc.c:1646  */
    break;

  case 89:
#line 400 "grammar.y" /* yacc.c:1646  */
    { ret_record->signal = (yyvsp[0].t_str); }
#line 2206 "grammar.c" /* yacc.c:1646  */
    break;

  case 90:
#line 403 "grammar.y" /* yacc.c:1646  */
    { ret_record->fs_type = (yyvsp[0].t_str); }
#line 2212 "grammar.c" /* yacc.c:1646  */
    break;

  case 91:
#line 405 "grammar.y" /* yacc.c:1646  */
    { ret_record->flags = (yyvsp[0].t_str); }
#line 2218 "grammar.c" /* yacc.c:1646  */
    break;

  case 92:
#line 407 "grammar.y" /* yacc.c:1646  */
    { ret_record->src_name = (yyvsp[0].t_str); }
#line 2224 "grammar.c" /* yacc.c:1646  */
    break;

  case 93:
#line 410 "grammar.y" /* yacc.c:1646  */
    {
		ret_record->event = AA_RECORD_INVALID;
		ret_record->info = (yyvsp[0].t_str);
	}
#line 2233 "grammar.c" /* yacc.c:1646  */
    break;

  case 94:
#line 417 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_DENIED; }
#line 2239 "grammar.c" /* yacc.c:1646  */
    break;

  case 95:
#line 418 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_AUDIT; }
#line 2245 "grammar.c" /* yacc.c:1646  */
    break;

  case 96:
#line 419 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_ALLOWED; }
#line 2251 "grammar.c" /* yacc.c:1646  */
    break;

  case 97:
#line 420 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_HINT; }
#line 2257 "grammar.c" /* yacc.c:1646  */
    break;

  case 98:
#line 421 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_STATUS; }
#line 2263 "grammar.c" /* yacc.c:1646  */
    break;

  case 99:
#line 422 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = AA_RECORD_ERROR; }
#line 2269 "grammar.c" /* yacc.c:1646  */
    break;

  case 100:
#line 425 "grammar.y" /* yacc.c:1646  */
    { ret_record->pid = (yyvsp[0].t_long); }
#line 2275 "grammar.c" /* yacc.c:1646  */
    break;

  case 101:
#line 428 "grammar.y" /* yacc.c:1646  */
    { ret_record->peer_pid = (yyvsp[0].t_long); }
#line 2281 "grammar.c" /* yacc.c:1646  */
    break;

  case 102:
#line 431 "grammar.y" /* yacc.c:1646  */
    { /* DROP */ }
#line 2287 "grammar.c" /* yacc.c:1646  */
    break;

  case 103:
#line 432 "grammar.y" /* yacc.c:1646  */
    { /* DROP */ }
#line 2293 "grammar.c" /* yacc.c:1646  */
    break;

  case 104:
#line 433 "grammar.y" /* yacc.c:1646  */
    { /* DROP */ }
#line 2299 "grammar.c" /* yacc.c:1646  */
    break;

  case 105:
#line 434 "grammar.y" /* yacc.c:1646  */
    { /* DROP */ }
#line 2305 "grammar.c" /* yacc.c:1646  */
    break;

  case 106:
#line 436 "grammar.y" /* yacc.c:1646  */
    { ret_record->event = lookup_aa_event((yyvsp[0].t_long)); }
#line 2311 "grammar.c" /* yacc.c:1646  */
    break;

  case 110:
#line 445 "grammar.y" /* yacc.c:1646  */
    { /* FIXME: this should probably convert back to a string proto name */
	  (yyval.t_str) = ipproto_to_string((yyvsp[0].t_long));
	}
#line 2319 "grammar.c" /* yacc.c:1646  */
    break;


#line 2323 "grammar.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (scanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (scanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, scanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, scanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (scanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, scanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, scanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 449 "grammar.y" /* yacc.c:1906  */


aa_log_record *
_parse_yacc(char *str)
{
	/* yydebug = 1;  */
	YY_BUFFER_STATE lex_buf;
	yyscan_t scanner;

	ret_record = NULL;
	ret_record = malloc(sizeof(aa_log_record));

	_init_log_record(ret_record);

	if (ret_record == NULL)
		return NULL;

#if (YYDEBUG != 0)
	yydebug = 1;
#endif

	aalogparse_lex_init(&scanner);
	lex_buf = aalogparse__scan_string(str, scanner);
	/* Ignore return value to return an AA_RECORD_INVALID event */
	(void)aalogparse_parse(scanner);
	aalogparse__delete_buffer(lex_buf, scanner);
	aalogparse_lex_destroy(scanner);
	return ret_record;
}
